mod collector;

use axum::routing::get;
use axum::Router;
use collector::{PromMetric, Worlds};

async fn metrics() -> String {
    let resp = reqwest::get("https://api.runelite.net/runelite-1.9.13/worlds.js")
        .await
        .unwrap()
        .json::<Worlds>()
        .await
        .unwrap();

    let metric_strings: Vec<String> = resp
        .worlds
        .into_iter()
        .map(|w| w.to_metric_string())
        .collect();
    metric_strings.join("\n")
}

#[tokio::main]
async fn main() {
    let app = Router::new().route("/metrics", get(metrics));

    println!("Starting...");

    axum::Server::bind(&"0.0.0.0:3000".parse().unwrap())
        .serve(app.into_make_service())
        .await
        .unwrap();
}
